<?php
//TITLE=English to romaji converter

$outset= 'euc-jp';
$title = 'English to romaji converter';
$progname = 'deeng';

ob_start();?>

<div style="font-size:120%">

<form method=GET action="http://bisqwit.iki.fi/source/deeng.html">
 Type here your english and press enter:<br>
 <input type=text size=30 name=engtext value="<?=htmlspecialchars($engtext)?>"><br>
 <small>Hint: Use two spaces if you don't want the words glued together
  (usually no recommended: you don't keep pauses in speech between words either).</small>
</form>

<?
if($engtext)
{
  function deeng_shellfix($s){return "'".str_replace("'", "'\''", $s)."'";}
  exec('/usr/local/bin/deeng -p '.deeng_shellfix($engtext).' 2>&1', $tmp);
  $phon = $tmp[0];
  $roma = $tmp[1];
  echo 'Here is your rmaji (<small>derived from <em>', htmlspecialchars($phon), '</em></small>):<pre>',
    htmlspecialchars(
      str_replace(array('a^','i^','o^','u^','e^','^'),
                  array('aa','ii','oh' ,'uu','ee','~'),
                  $roma)),
    '</pre>';
  if(file_exists('/root/src/kr2kb.sed'))
  {
    echo 'This is it in HIRAGANA: ';
    $res = exec('echo '.deeng_shellfix($roma).'|sed -f /root/src/kr2kb.sed|/usr/local/bin/htmlrecode -Ieucjp -Oiso-8859-1');
    print str_replace(' ', '', str_replace('^', '&#x30FC;', $res));
  }
  if(file_exists('/root/src/rom2kat.sed'))
  {
    echo '<br>This is it in KATAKANA: ';
    $res = exec('echo '.deeng_shellfix($roma).'|sed -f /root/src/rom2kat.sed|/usr/local/bin/htmlrecode -Ieucjp -Oiso-8859-1');
    print str_replace(' ', '', str_replace('^', '&#x30FC;', $res));
  }
}

?>
</div>

<?$demo=ob_get_contents();
ob_end_clean();

$text = array(
   '1. Purpose' => "

This program converts english words, names and sentences to rmaji
by transforming them to phonemes and then converting the phonemes
to rmaji.<br>
Rmaji (&#12525;&#12540;&#12510;&#23383;) is the romanization
(transliteration to latin characters) of the japanese writing.<br>
This page therefore contains an english to japanese writing -converter.

", '1. Online demo' => "

$demo
<b><font color=\"#802020\">
NOTE: This is not a translator!
This is not a <a href=\"http://kanjidict.stc.cx/japkanji.php\">dictionary</a>!
<br>Your text will not be japanese!<br>
It's only japanese writing, not japanese language.</font></b>
<p>
Sorry, I do not have a reverse
converter (katakana to english) here.<br>
But I do have a <a href=\"http://kanjidict.stc.cx/kakasifilt.php\">kana and kanji to rmaji filter</a>.
<p>
If you want to convert rmaji to english, try looking the words up
from a <a href=\"http://kanjidict.stc.cx/japkanji.php\">dictionary</a>.

", '1. Copying' => "

deeng has been written by Joel Yliluoma, a.k.a.
<a href=\"http://iki.fi/bisqwit/\">Bisqwit</a>,<br>
and is distributed under the terms of the
<a href=\"http://www.gnu.org/licenses/licenses.html#GPL\">General Public License</a> (GPL).
<p>
The English to phonemes tables and code were directly
copied from the public domain rsynth-2.0 project (speech synthesizer),
which copies the data from a publication from 1976.

", '1. Quality notes' => "

Phoneme code to rmaji conversion is based on a direct conversion
with no dictionary, so you might get different results than when
looking at your <a href=\"http://kanjidict.stc.cx/japkanji.php\">dictionary</a>.
<p>
The conversion program is quite logical and straightforward.<br>
English isn't. Therefore the results might not be the best quality.
An example of poorly converted word is \"what\".

", '1. Requirements' => "

GNU make is required.<br>

");
include '/WWW/progdesc.php';
